**********************************************************************
* Nom:		Puzzle Bobble v2.0
* Auteur :		Lilian Pigallio & Denis Martinez
*
* Pile:	7: #Paramtres de sortie : #0=quitter, #1=gagn, #2=perdu
*		6: Grob tableau 80*16
*		5: Grob dcrivant la srie de billes
*		4: #Paramtres d'entre :
*			 bit0=1 si trace,
*			 bit1=1 si mode 2 joueurs,
*			 bit2=1 si IR en 2 joueurs, ou Practice en 1 joueur 
*			 bit4  11 = nb de tirs entre chaque insertion de lignes
*			 bit12  15 = nb de lignes initiales en mode Practice ou 2J
*		3: Grob billes 8*192
*		2: Grob image du bas de l'cran 56 * 64
*		1: Grob animation du monstre
*
* Description:	Le jeux sur HP48S,SX,G,GX et Hp49  compiler avec JAZZ
*			 stocker sous -> PZB.EXE
*
* Pr-requis :	L'affichage est un dbut d'un cran 136*320
*
* Gestion Interne:
*		R0,R1 libres
*		R2[B]	= offset des coordonnes de la bille  afficher
*		R3[A] = cran o l'on travaille
*		R4[A] = ->data
*		D0 doit toujours pointer dans les Data en sortie de fct
*		ST(0) = 0 si travail dans cran 0, 1 si dans cran 1
*		ST(1) = 1 si l'affichage de la bille recouvre qqchose
*		ST(2) = 1 si la bille est en train de se dplacer
*		ST(3) = 1 s'il faut afficher le parcours
*		ST(4) = 1 s'il faut faire chuter les billes
*		ST(5) = 1 si on peut insrer les billes
*		ST(6) = 1 si mode 2 joueurs
*		ST(7) = 1 si IR en 2 joueurs, ou Practice en 1 joueur
*		ST(8) = 1 si une donne a t mise 
*		ST(9)	= cpt pour l'affichage des billes  effacer
*		ST(10)= 1 pour retirer les billes non accroches !
*		ST(11)= 1 pour l'appel  la suppression des billes !
**********************************************************************
{
CODE

* taille des variables
			ABASE	0
ECRAN0		ALLOC 5	adresse du 1er cran d'affichage
ECRAN1		ALLOC 5	adresse du 2e cran d'affichage
ECRAN_FOND		ALLOC 5	adresse de l'cran de fond
ECRAN_CHUTE		ALLOC 5	adresse de l'cran des billes qui tombent
ECRAN_GRIS		ALLOC 5	adresse de l'cran pour le gris clair
IMAG_BILLES		ALLOC	5	Adresse dans le grob des billes
IMAG_BAS		ALLOC	5	Adresse dans le grob de l'image du bas
TABLEAU		ALLOC 5	tableau contenant les billes affiches
TAB_COS		ALLOC	5	table des cosinus (de 12  168)
TAB_SIN		ALLOC 5	tables des sinus (de 12  168

CANON_DIRECT	ALLOC 2	direction du canon de 0..78 (12  168)

AFF_BILLE		ALLOC	0
AFF_BILLE_X		ALLOC	5	abscisse de la bille  afficher 0..56 dec(2,3)
AFF_BILLE_Y		ALLOC	5	abscisse de la bille  afficher 0..123 dec(2,3)
AFF_BILLE_TYPE	ALLOC 2	type de la bille  afficher
AFF_BILLE_DIRECT	ALLOC 2	direction de la bille  afficher 0..78 (12..168)
AFF_BILLE_SAVE	ALLOC	14	sauvegarde de la bille coordonnes + type & direct

TAB_BILLE		ALLOC	0
TAB_BILLE_X		ALLOC	5	abscisse de la bille du tableau  afficher
TAB_BILLE_Y		ALLOC	5	abscisse de la bille du tableau  afficher 
TAB_BILLE_TYPE	ALLOC 2	type de la bille du tableau  afficher 

NEXT_BILLE		ALLOC	0
NEXT_BILLE_X	ALLOC	5	abscisse de la bille suivante
NEXT_BILLE_Y	ALLOC	5	abscisse de la bille suivante 
NEXT_BILLE_TYPE	ALLOC 2	type de la bille suivante 

WAIT_BILLE		ALLOC	0
WAIT_BILLE_X	ALLOC	5	abscisse de la bille en attente
WAIT_BILLE_Y	ALLOC	5	abscisse de la bille en attente 
WAIT_BILLE_TYPE	ALLOC 2	type de la bille en attente 

TIME_BILLE		ALLOC	0
TIME_BILLE_X	ALLOC	5	abscisse de la bille du temps restant
TIME_BILLE_Y	ALLOC	5	abscisse de la bille du temps restant 
TIME_BILLE_TYPE	ALLOC 2	type de la bille du temps restant 

NB_BILLES_IDEM	ALLOC	2	nb de billes identiques pour la suppression	
NB_BILLES_ENVOI	ALLOC	2	nb de billes  envoyer	
NB_BILLES_RECEP	ALLOC	2	nb de billes reues
NB_BILLES_INSERT	ALLOC	2	nb de billes  insres

NB_LIGNES_INIT	ALLOC	2	nb de lignes initiales en mode 2 joueurs
NB_LIGNES_INSERT	ALLOC	2	nb de lignes insres
NB_TIRS_MAX		ALLOC	2	nb entre 2 insertions de lignes (par le haut)
NB_TIRS_COURANT	ALLOC	2	nb de tirs avant l'insertion d'une ligne

SERIE_B_DEBUT 	ALLOC	5	adresse du dbut de la srie de billes
SERIE_B_NEXT 	ALLOC	5	adresse de la prochaine bille de la srie

PARAMS_SORTIE	ALLOC	5	adresse des paramtre de sortie

SAUVE_ST		ALLOC	3	sauvegarde des flags ST
SAUVE_R3		ALLOC	5	sauvegarde de R3
SAUVE_TIMER		ALLOC	8	sauvegarde du timer
SAUVE_EMIT		ALLOC	2	sauvegarde de la donne mise

SAV_TIMER2		ALLOC 8	sauvegarde TIMER2
SAV_IT		ALLOC 16	sauvegarde valeur avant detournement des INTS
INT_EXECUTEE	ALLOC	1	pour savoir si une INT a eu lieu
INT_CPT		ALLOC	1	compteur pour les INTs

IMAGE_MONSTRE	ALLOC	5	adresse des images de l'anim du monstre

	GOSBVL	=SAVPTR
*	GOSBVL	=DisableIntr
	INTOFF
	GOSUBL	InitGame
	GOSUBL	Grey_ON
	GOSUBL 	Init2Joueurs 	* Init COM si 2 joueurs + nb de lignes

	GOSUBL	Affiche_Tableau
	GOSUBL	InitBille 
	GOSUBL	InitTime

MAIN_BCL

	?ST=0		5			* faire les tests ?
	GOYES		MAIN_pas_insert
		GOSUBL	Insert_billes
		GOSUBL	Test_Gagne_Perdu 
		GOSUBL	Test_Insert_lign
		GOSUBL	InitTime	* on repart sur 10 sec
MAIN_pas_insert 

	?ST=0		11			* test de suppression
	GOYES		MAIN_pas_suppr
		?ST=0	9			* supprimer maintenant ??
		GOYES MAIN_pas_suppr0
			GOSUBL	Suppr_Tableau	* supprime les billes identiques
			ST=0	9
			GOTO	MAIN_pas_suppr 
MAIN_pas_suppr0
		ST=1	9
MAIN_pas_suppr

	?ST=0		10			* test des billes qui tombent
	GOYES		MAIN_pas_suppr2
		GOSUBL	Suppr2_Tableau
MAIN_pas_suppr2

	GOSUBL	Copie_ecran_fond 

	LC(2)		AFF_BILLE 
	R2=C.F	B			* on affiche la bille qui se dplace
	GOSUBL	Affiche_Bille 
	?ST=0		1			* test si collision 
	GOYES		MAIN_pas_collis 
		?ST=0		2			* test si mouvement
		GOYES		MAIN_pas_collis 
			GOSUBL	Mise_en_Tableau 
			GOSUBL	Affiche_Tableau
			GOSUBL	InitBille 
MAIN_pas_collis 

	?ST=1		2			* test si pas de mouvement
	GOYES		MAIN_mouvement 
		D0=(2)	CANON_DIRECT	* direction bille = direction canon
		C=DAT0	B
		D0=(2)	AFF_BILLE_DIRECT 
		DAT0=C	B
		?ST=0		3			* test si affichage parcours
		GOYES		MAIN_pas_parc
			GOSUBL	Affiche_Parcours
MAIN_pas_parc
		GOSUBL 	Affiche_Canon 
		GOSUBL 	Affiche_Time 
		GOSUBL	Test_Vibra_lign
MAIN_mouvement 

	GOSUBL 	Copie_image_bas
	GOSUBL 	ChangeEcran		* Affichage !!!!!!!!!!!!!!!!!

	?ST=0		2			* test si mouvement
	GOYES		MAIN_pas_mvt
		GOSUBL	Deplace_Bille 

* test si Y n'est pas ngatif
		D0=(2)	AFF_BILLE_Y 
		C=DAT0	A
		CSR		A			* on supprime les 3 quartets dcimaux
		CSR		A
		CSR		A
		?CBIT=0	7
		GOYES 	MAIN_pas_mvt 	* pas ngatif
			GOSUBL	Mise_en_Tableau 
			GOSUBL	Affiche_Tableau
			GOSUBL	InitBille 
MAIN_pas_mvt 


	GOSUBL 	Gestion_touches 

	?ST=0		6
	GOYES		MAIN_pas_2j
		GOSUBL 	Echanges_2j 
MAIN_pas_2j 

	GOTO		MAIN_BCL			* on boucle





**********************************************************************
Gestion_touches
**********************************************************************
* gestion des touches
* Attention : masques pour la HP49

	?ST=1		2		* bille dj en mvt -> pas de mvt
	RTNYES

* test si aucune touche
	LC(3)		#1FF
	OUT=C
	GOSBVL	=AINRTN
	?A#0		X
	GOYES		Tch_touches
		GOLONG Anim_monster
*		le RTN est fait dans Anim_monster 
Tch_touches
	
* teste flche haute
	LC(3)		#040
	OUT=C
	GOSBVL	=AINRTN
	?ABIT=0	3			* flche haute = 0008
	GOYES		Tch_pas_haut
		D0=(2)	CANON_DIRECT
		C=DAT0	B
		?C=0		B		* test si pas dj 0
		GOYES		Tch_pas_haut
			C=C-1		B
			DAT0=C	B
			GOSUBL	Beep_mvt_canon 
Tch_pas_haut


* teste flche basse
	LC(3)		#040
	OUT=C
	GOSBVL	=AINRTN
	?ABIT=0	1			* flche basse = 0002
	GOYES		Tch_pas_bas
		D0=(2)	CANON_DIRECT
		C=DAT0	B
		LA(2)		#4E		* valur max = 78
		?C=A		B		* test si pas dj max
		GOYES		Tch_pas_bas
			C=C+1		B
			DAT0=C	B
			GOSUBL	Beep_mvt_canon 
Tch_pas_bas


* teste tir = SPC
	LC(3)		#002
	OUT=C
	GOSBVL	=AINRTN
	?ABIT=0	0			* SPC = 0001
	GOYES		Tch_pas_tir
		D0=(2)	NB_TIRS_COURANT 
		C=DAT0	B
		C=C-1		B	* nb de tir -1 avant insertion ligne
		DAT0=C	B
		GOSUBL	Beep_tir_canon 
		GOSUBL	InitTime
		ST=1	2			* bille en mvt

* plus de marge  gauche
		D1=(5)	#00100	* sur la marge  gauche
		LC(1)		#8
		DAT1=C	1
Tch_pas_tir


* teste sortie = BackSPace
	LC(3)		#001
	OUT=C
	GOSBVL	=AINRTN
	?ABIT=0	6			* BackSPace = 0040
	GOYES		Tch_pas_sortie
		?ST=0		6
		GOYES		Tch_Retour_RPL 
			LA(2)		#8F		* on envoie Perdu
			GOSUBL	Emit_chr

Tch_Retour_RPL
		LC(3)		#1FF		* on attend plus aucun touche
		OUT=C
Tch_wait
		GOSBVL	=AINRTN
		?A#0		X
		GOYES		Tch_wait

* c'est fini, on efface tout
		D0=(2)	ECRAN0
		C=DAT0	A
		D1=C				* D1 dans display
		LC(5)		#00197	* (34 quartets * 192 lignes) / 16 - 1
		A=0		W
Tch_eff
		DAT1=A	16
		D1=D1+	16
		C=C-1		A
		GONC		Tch_eff 

		GOSUBL	Grey_OFF

		D1=(5)	#00120	* on restaure le bon cran
		GOSBVL	=D0->Row1	* A(A) pointe dans le grob courant
		DAT1=A	A

		GOSBVL	=AllowIntr	* On retourne au RPL !!
		GOSBVL	=GETPTR
		A=DAT0	A
		D0=D0+	5
		PC=(A)
Tch_pas_sortie 

	RTN


**********************************************************************
Test_Gagne_Perdu
**********************************************************************
* On va tester si on a gagn = plus rien sur la 1ere ligne en mode 1 joueur
* ou perdu = des billes sur la 12e ligne

* test si GAGNE
	?ST=1		6			* pas de test gagn en mode 2j
	GOYES		test_gp_pas_gagn
	D0=(2)	NB_LIGNES_INSERT 	* on va tester aprs les lignes insres
	C=0		A
	C=DAT0	B
	A=C		A
	A=A+A		A
	A=A+A		A			* nb de lignes * 4
	CSL		A			* nb de lignes * 16
	A=A+C		A			* nb de lignes * 20
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,12		* on saute 1ere ligne et 1er MUR
	C=C+A		A		* ajout nb de lignes insres
	D1=C				* D1 dans tableau !
	C=DAT1	W		* toujours ligne de 8 billes
	?C#0		W
	GOYES		test_gp_pas_gagn
test_gp_GAGNE
		D0=(2)	PARAMS_SORTIE
		C=DAT0	A
		D1=C
		LC(1)		#1			* GAGNE !!!
		DAT1=C	1

		LC(5)		#00400
		D=C		A
test_gp_wait1
		GOSUBL	Anim_monster
			D=D-1		A
		GONC		test_gp_wait1
		GOTO		Tch_Retour_RPL
test_gp_pas_gagn 

* test si perdu
	D0=(2)	TABLEAU
	A=DAT0	A		* dbut tableau
	LC(5)		#000F2	* (12 lignes * 20 quartets) + 2
	A=A+C		A
	D1=A				* D1 dans tableau !

	D0=(2)	NB_LIGNES_INSERT 	* en fct du nb de ligne on a 7 ou 8 billes
	A=DAT0	B
	?ABIT=1	0
	GOYES		test_gp_impair
		C=0		W
		C=DAT1	14		* ligne avec 7 billes
		GOTO		test_gp_test_per
test_gp_impair 
		C=DAT1	W		* ligne avec 8 billes
test_gp_test_per 
	?C=0		W
	GOYES		test_gp_pas_perd
		?ST=0		6
		GOYES		test_gp_pas_2j
			LA(2)		#8F		* on envoie Perdu
			GOSUBL	Emit_chr
test_gp_pas_2j
		D0=(2)	PARAMS_SORTIE
		C=DAT0	A
		D1=C
		LC(1)		#2			* PERDU !!!
		DAT1=C	1

		LC(5)		#00600
		D=C		A
test_gp_wait2
		GOSUBL	Anim_monster
			D=D-1		A
		GONC		test_gp_wait2
		GOTO	Tch_Retour_RPL
test_gp_pas_perd 

	RTN


**********************************************************************
Test_Insert_lign
**********************************************************************
* test si on doit insrer un ligne par le haut

	D0=(2)	NB_TIRS_COURANT 
	C=DAT0	B
	?CBIT=1	7				* on est en ngatif !
	GOYES		tst_ins_lign 

	?C#0		B				* pas encore bon
	RTNYES

tst_ins_lign
	GOSUBL 	Insert_ligne 
	GOSUBL	Affiche_Tableau

	D0=(2)	NB_TIRS_MAX 
	C=DAT0	B
	D0=(2)	NB_TIRS_COURANT 
	DAT0=C	B				* remise au MAX
	
	ST=1		5		* il faudra tester le gagn/perdu
	RTN


**********************************************************************
Test_Vibra_lign
**********************************************************************
* test si on doit faire vibrer l'cran avant l'insertion d'une ligne

	D0=(2)	NB_TIRS_COURANT 
	A=DAT0	B
	?A=0		B
	RTNYES					*  0 -> on insre la ligne
	LC(2)		#02				* encore 2 billes
	?A>C		B				* pas encore de vibration
	RTNYES
	
	D0=(2)	SAV_TIMER2			* horloge
	C=DAT0	A

	?ABIT=1	0
	GOYES		tst_vibr_1	
* 2  billes, on teste le bit 11
		?CBIT=0	11
		GOYES		tst_vibr_marg0
			LC(1)	#9			* marge  1
			GOTO	tst_vibr_ecrit
tst_vibr_marg0
		LC(1)	#8				* marge  0
		GOTO	tst_vibr_ecrit
tst_vibr_1
* plus qu'une bille, on teste le bit 10
	?CBIT=0	10
	GOYES		tst_vibr_marg0
		LC(1)	#9				* marge  1

tst_vibr_ecrit
	D1=(5)	#00100			* sur la marge  gauche
	DAT1=C	1

	RTN


**********************************************************************
Insert_ligne
**********************************************************************
* On insre une ligne de bille par le haut

* on dcale vers le bas toutes les lignes
	D0=(2)	TABLEAU 
	A=DAT0	A
	LC(5)		#0011C		* (15 lignes * 20 quartets) - 16
	C=C+A		A
	D1=C					* D1 sur la dernire ligne
	D0=C
	D0=D0-	16
	D0=D0-	4			* D0 sur l'avant dernire ligne
	LC(2)		#10			* ((13 lignes * 20 quartets)) / 16 - 1
Ins_lg_decale
	A=DAT0	W
	DAT1=A	W
	D0=D0-	16
	D1=D1-	16
	C=C-1		B
	GONC		Ins_lg_decale 

	C=R4.F	A
	D0=C

* on va initialiser la nouvelle ligne
	D0=(2)	NB_LIGNES_INSERT
	A=DAT0	B
	A=A+1		B			* nb de lignes insres ++
	DAT0=A	B

	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,12		* on saute 1ere ligne et 1er MUR
	D1=C				* D1 dans la 1ere ligne
	?ST=1		6
	GOYES		Ins_lg_2joueurs
		?ST=0		7
		GOYES		Ins_lg_1joueur
Ins_lg_2joueurs 
* 2 joueurs, on insre une ligne de billes au hasard
		LC(1)		#6		* 7 billes au hasard
		?ABIT=1	0
		GOYES		Ins_lg_insere
			C=C+1	P		* 8 billes si ligne paire
Ins_lg_insere
		D0=(5)	#00138	* horloge
		A=DAT0	8		* lecture pour faire modifier le CRC
		D0=(2)	#04		* D0 dans le CRC
		A=DAT0	1		*  2 joueurs on insre des billes
		ABIT=0	3
*		?A#0		P
*		GOYES		Ins_lg_pas_vide
*			LA(1)	#2		* bille 2 par dfaut
* Ins_lg_pas_vide
		DAT1=A	1
		D1=D1+	2
		C=C-1		P
		GONC		Ins_lg_insere

* on fini par un mur
		LC(1)		#F		* MUR
		DAT1=C	1
		C=R4.F	A
		D0=C
		GOTO		Ins_lg_fin

Ins_lg_1joueur
* 1 joueur, on dcale vers le bas
	LC(2)		#01		* 1ere ligne ?
	?A#C		B
	GOYES		Ins_lg_pas_1ere
		LC(8)	#0E0E0E0E	* 7 poussoir et un MUR
		P=	8
		LC(8)	#0F0E0E0E
		P=	0
		GOTO	Ins_lg_ecrit
Ins_lg_pas_1ere
	?ABIT=1	0
	GOYES		Ins_lg_impair
		LC(8)	#0C0C0C0B	* 8 barres
		P=	8
		LC(8)	#0A0C0C0C
		P=	0
		GOTO	Ins_lg_ecrit
Ins_lg_impair
	LC(8)	#0D0D0D0D		* 7 barres et un MUR
	P=	8
	LC(8)	#0F0D0D0D
	P=	0
	GOTO	Ins_lg_ecrit
Ins_lg_ecrit 
	DAT1=C	16

Ins_lg_fin
	GOSUBL	Affiche_Tableau
	GOSUBL	Beep_insert_lign 

	RTN


**********************************************************************
Insert_billes
**********************************************************************
* On insre les billes par le bas

	D0=(2)	NB_BILLES_RECEP 
	A=DAT0	B
	?A#0		B
	GOYES 	ins_b_pas0
		ST=0	5			* test effectu
		RTN 				* pas de billes  inserer
ins_b_pas0
	LC(2)		#05
	?A<=C		B			* pas plus de 5 billes  la fois
	GOYES		ins_b_nb_ok
		A=C	B
ins_b_nb_ok
	C=DAT0	B
	C=C-A		B
	DAT0=C	B			* on retire les billes insres
	D0=(2)	NB_BILLES_INSERT
	DAT0=A	B

	D0=(2)	AFF_BILLE		* sauvegarde bille affichage
	A=DAT0	14
	D0=(2)	AFF_BILLE_SAVE 
	DAT0=A	14

ins_b_init
* initialisation de la bille  insrer
	D1=(5)	#00104			* dans le CRC (nb au hasard)
	D0=(2)	AFF_BILLE_X 
	C=DAT1	B
	CBIT=0	6
	CBIT=0	7				* valeur de 0..63
	LA(2)		#38				* max X = 56d
	?C<=A		B
	GOYES		in_b_X_ok
		C=A	B
in_b_X_ok
	CSL		A
	CSL		A
	CSL		A
	DAT0=C	A

	D0=(2)	AFF_BILLE_Y 
	LC(5)		#58000			* = 88,000
	DAT0=C	A

	D0=(2)	AFF_BILLE_TYPE 
	C=0		B
	C=DAT1	1
	CBIT=0	3				* valeur entre 1 et 7
	?C#0		B
	GOYES		Ins_b_N_ok
		LC(2)	#01				* bille 1 si null
Ins_b_N_ok 
	DAT0=C	B

	D0=(2)	AFF_BILLE_DIRECT 
	LC(2)		#27		*  la verticale (39)
	DAT0=C	B

Ins_b_boucle
* boucle d'affichage
		GOSUBL	Copie_ecran_fond 

		LC(2)		AFF_BILLE 
		R2=C.F	B			* on affiche la bille qui se dplace
		GOSUBL	Affiche_Bille 
		?ST=0		1			* test si collision 
		GOYES		Ins_b_pas_collis 
			GOSUBL	Mise_en_Tableau 
			GOSUBL	Affiche_Tableau
			GOSUBL	InitBille 
			GOTO		ins_b_fin_boucle 
Ins_b_pas_collis 

		GOSUBL 	Copie_image_bas
		GOSUBL 	ChangeEcran		* Affichage !!!

		GOSUBL	Deplace_Bille 
		GOSUBL	Deplace_Bille 

* test si Y n'est pas ngatif
		D0=(2)	AFF_BILLE_Y 
		C=DAT0	A
		CSR		A			* on supprime les 3 quartets dcimaux
		CSR		A
		CSR		A
		?CBIT=0	7
		GOYES 	Ins_b_boucle	* pas ngatif

		GOSUBL	Mise_en_Tableau 
		GOSUBL	Affiche_Tableau
		GOSUBL	InitBille 

ins_b_fin_boucle
	D0=(2)	NB_BILLES_INSERT
	C=DAT0	B
	C=C-1		B
	?C=0		B
	GOYES		ins_b_fin
		DAT0=C	B
		GOTO		ins_b_init	* bille suivante
ins_b_fin 
	D0=(2)	AFF_BILLE_SAVE	* restauration bille affichage
	A=DAT0	14
	D0=(2)	AFF_BILLE 
	DAT0=A	14

	ST=0		11			* pas de test de suppression
	ST=0		5			* test effectu

	GOSUBL 	AffichBillesWait 
	RTN


**********************************************************************
Affiche_Time
**********************************************************************
* On affiche le temps restant et fait partir la bille si 0

	D0=(2)	SAUVE_TIMER
	A=DAT0	8			* valeur sauvegarde
	D0=(2)	SAV_TIMER2
	C=DAT0	8			* valeur courante
	P=		7
	C=A-C		WP			* temps coul
	CSR		WP 
	CSR		WP
	CSR		WP
	CSRB.F	WP			* nb de seconde coules
	P=		0
	LA(5)		#0000A		* 10 secondes
	A=A-C		A
	?ABIT=0	15			* test si ngatif
	GOYES		aff_tim_pas0
		?ST=1		2		* dj en mvt
		RTNYES
		D0=(2)	NB_TIRS_COURANT 
		C=DAT0	B
		C=C-1		B	* nb de tir -1 avant insertion ligne
		DAT0=C	B
		GOSUBL	Beep_tir_canon 
		GOSUBL	InitTime
		ST=1		2		* on lance la bille
* plus de marge  gauche
		D1=(5)	#00100	* sur la marge  gauche
		LC(1)		#8
		DAT1=C	1
		RTN
aff_tim_pas0

	LC(2)		#05
	?A>C		B			* plus de 5 secondes
	RTNYES

	LC(2)		#10			* slection bille
	A=A+C		A
	D0=(2)	TIME_BILLE_TYPE
	DAT0=A	B

* on affiche la bille du temps
	LC(2)		TIME_BILLE 
	R2=C.F	B			
	GOSUBL	Affiche_Bille
	RTN


**********************************************************************
Affiche_Canon
**********************************************************************
* On affiche le cannon
* Utilisation de R0(W) !!!

* Sauvegarde des valeurs de AFF_BILLE dans R0
	D0=(2)	AFF_BILLE 
	C=DAT0	14	* 5q pour X, 5q pour Y, 2q pour type et 2q pour direct
	R0=C

	D0=(2)	AFF_BILLE_X 
	LC(5)		#1C800			* = 28,500
	DAT0=C	A
	D0=(2)	AFF_BILLE_Y 
	LC(5)		#52800			* = 82,500
	DAT0=C	A

	D0=(2)	AFF_BILLE_TYPE
	C=0		B
	DAT0=C	B				* bille de type trace

	D0=(2)	CANON_DIRECT		* direction bille = direction canon
	C=DAT0	B
	D0=(2)	AFF_BILLE_DIRECT 
	DAT0=C	B

	GOSUBL	Deplace_Bille
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 


* on affiche la bille qui se dplace
	LC(2)		AFF_BILLE 
	R2=C.F	B			
	GOSUBL	Affiche_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Affiche_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Affiche_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Affiche_Bille 

* Restauration des valeurs de AFF_BILLE depuis R0
	C=R0
	D0=(2)	AFF_BILLE
	DAT0=C	14

	RTN


**********************************************************************
Affiche_Parcours
**********************************************************************
* On affiche le parcours de la bille AFF_BILLE avec des pointills
* Utilisation de R0(W) et R1(B)!!!

* Sauvegarde des valeurs de AFF_BILLE dans R0
	D0=(2)	AFF_BILLE 
	C=DAT0	14	* 5q pour X, 5q pour Y, 2q pour type et 2q pour direct
	R0=C

	D0=(2)	AFF_BILLE_TYPE
	C=0		B
	DAT0=C	B		* bille de type trace

* la trace avance en fonction du timer 2
	D0=(2)	SAV_TIMER2
	D0=D0+	2
	C=DAT0	B
	C=-C		B
	CSRB		B
	CBIT=0	3		* C(P) entre 0 et 7

Aff_parc_bcl
	?C=0		P
	GOYES		Aff_parc_rtn 
	R1=C		B
	GOSUBL	Deplace_Bille 
	C=R1		B
	C=C-1		B
	GOTO		Aff_parc_bcl

Aff_parc_rtn
	GOSUBL	Deplace_Bille 	* 8 dplacements
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 
	GOSUBL	Deplace_Bille 

* on affiche tant que Y n'est pas ngatif
	D0=(2)	AFF_BILLE_Y 
	C=DAT0	A
	CSR		A			* on supprime les 3 quartets dcimaux
	CSR		A
	CSR		A
	?CBIT=1	7
	GOYES 	Aff_parc_fin 

* on affiche la bille qui se dplace
	LC(2)		AFF_BILLE 
	R2=C.F	B			
	GOSUBL	Affiche_Bille 
* on affiche tant que pas de collision
	?ST=0		1
	GOYES		Aff_parc_rtn 

Aff_parc_fin
* Restauration des valeurs de AFF_BILLE depuis R0
	C=R0
	D0=(2)	AFF_BILLE
	DAT0=C	14

	RTN



**********************************************************************
Mise_en_Tableau
**********************************************************************
* On insre la bille d'affichage AFF_BILLE dans le tableau des billes TABLEAU

	D0=(2)	NB_LIGNES_INSERT
	C=DAT0	B
	B=C		B		* B = numro de ligne

	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,10		* on saute 1ere ligne
	D1=C				* D1 dans tableau !

* on cherche d'abord la ligne
	D0=(2)	AFF_BILLE_Y
	A=DAT0	A
	ASR		A			* on supprime les 3 quartets dcimaux
	ASR		A
	ASR		A
	LC(2)		#04
Mistab_ligne_rtn
	A=A-C		B
	?ABIT=1	7			* valeur ngative ?
	GOYES 	Mistab_ligne_ok 	* c'est la bonne ligne
		B=B+1		B		* ligne suivante
		D1=D1+	10
		D1=D1+	10
		LC(2)		#07
		GOTO		Mistab_ligne_rtn
Mistab_ligne_ok
	D1=D1+	2			* on saute le mur

* on cherche la colonne
	D0=(2)	AFF_BILLE_X
	A=DAT0	A
	ASR		A			* on supprime les 3 quartets dcimaux
	ASR		A
	ASR		A
	C=B		B
	?CBIT=0	0
	GOYES		Mistab_lg_paire
		LC(2)		#04
		A=A-C		B		* on enlve le dcalage de lignes impaires
Mistab_lg_paire

	LC(2)		#04
Mistab_col_rtn
	A=A-C		B
	?ABIT=1	7			* valeur ngative ?
	GOYES 	Mistab_col_ok 	* c'est la bonne colonne
		D1=D1+	2		* colonne suivante
		LC(2)		#08
		GOTO		Mistab_col_rtn
Mistab_col_ok

* on affecte la bille
	C=DAT1	B
	?C=0		P
	GOYES		Mistab_case_ok
		D1=D1+	2		* case suivante
		C=DAT1	B
		?C=0		P
		GOYES		Mistab_case_ok
			D1=D1-	4	* case prcdente
Mistab_case_ok
	D0=(2)	AFF_BILLE_TYPE
	C=DAT0	B
	?ST=1		5
	GOYES		Mistab_ins_b	* insertion bille pas le bas	
		CBIT=1	4		* on marque la bille pour suppression
Mistab_ins_b
	DAT1=C	B

	?ST=1		5
	RTNYES				* pas de test si insertion par le bas

	D0=(2)	NB_BILLES_IDEM
	LC(2)		#01
	DAT0=C	B			* dj une bille  effacer
	ST=1		11			* il faudra faire le test de suppression
	
	RTN


**********************************************************************
Suppr_Tableau
**********************************************************************
* on supprime si 3 billes identiques 
* Pr requis : les billes  effacer doivent tre marques, Bit4 = 1
* Utilisation de ST(11) et R0(A), maj de ST(10)

	ST=0		11		* pas de nouvelle bille marque

	D0=(2)	NB_LIGNES_INSERT
	C=DAT0	B
	B=C		B		* B = numro de ligne
	D=0		B		* D = numro de bille
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,10		* on saute 1ere ligne
	R0=C.F	A
	D1=C
Ret_b_suppr_tab
	C=DAT1	B		* lecture valeur de la bille
	?CBIT=0	4		* pas marque
	GOYES		Fin_b_suppr_tab
		?C=0		P
		GOYES		Fin_b_suppr_tab
* test avec bille prcdente	
			D1=D1-	2
			GOSUB		Suppr_Tab_test
* test avec bille suivante
			D1=D1+	4
			GOSUB		Suppr_Tab_test

			A=B		B
			?ABIT=0	0		* ligne paire ?
			GOYES		suppr_tab_paire
* test avec bille ligne suivante
				D1=D1+	10
				D1=D1+	8
				GOSUB		Suppr_Tab_test
* test avec bille ligne suivante + 1
				D1=D1+	2
				GOSUB		Suppr_Tab_test
* test avec bille ligne prcdente + 1
				D1=D1-	10
				D1=D1-	10
				D1=D1-	10
				D1=D1-	10
				GOSUB		Suppr_Tab_test
* test avec bille ligne prcdente
				D1=D1-	2
				GOSUB		Suppr_Tab_test
				GOTO	Fin_b_suppr_tab
suppr_tab_paire 
* test avec bille ligne suivante - 1
			D1=D1+	10
			D1=D1+	6
			GOSUB		Suppr_Tab_test
* test avec bille ligne suivante
			D1=D1+	2
			GOSUB		Suppr_Tab_test
* test avec bille ligne prcdente
			D1=D1-	10
			D1=D1-	10
			D1=D1-	10
			D1=D1-	10
			GOSUB		Suppr_Tab_test
* test avec bille ligne prcdente - 1
			D1=D1-	2
			GOSUB		Suppr_Tab_test

Fin_b_suppr_tab
	D=D+1		B		* bille suivante
	LC(2)		#0A		* fin de ligne ?
	?C#D		B
	GOYES		suppr_tab_pas_li
		D=0	B
		B=B+1	B		* ligne suivante
		LC(2)	#0C		* 12 lignes
		D0=(2)	NB_LIGNES_INSERT
		A=DAT0	B
		C=C+A		B
		?B=C		B
		GOYES		suppr_tab_fin
suppr_tab_pas_li
	C=R0.F	A
	C=C+CON	A,2
	R0=C.F	A
	D1=C
	GOTO		Ret_b_suppr_tab 

suppr_tab_fin
* on boucle tant que des billes ont t marques
	?ST=0		11
	GOYES		suppr_tab_final
		GOTO		Suppr_Tableau

suppr_tab_final 
*	ST=0		11		* pas 3 billes par dfaut		
	D0=(2)	NB_BILLES_IDEM
	A=DAT0	B

	LC(2)		#03
	?A<C		B		* pas 3 billes !
	GOYES		suppr_tab_pas3
		ST=1	11		* assez de bille !!!
		ST=1	10		* faudra tester les billes qui tombent
		A=A-C	B		* nb de bille - 3
		D0=(2)	NB_BILLES_ENVOI 
		C=DAT0	B
		C=C+A		B
		DAT0=C	B	* incrment du nb de billes  envoyer 
		GOTO		suppr_tab_3
suppr_tab_pas3
	ST=1		5		* faudra insrer les billes
suppr_tab_3


* on boucle sur toutes les billes pour supprimer ou effacer les flags
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,12		* on saute 1ere ligne + 1er mur
	D1=C
	LA(2)		#77		* (10 billes * 12 lignes) - 1
Ret_f_suppr_tab
	C=DAT1	B
	?CBIT=0	4		* test si marqu
	GOYES		suppr_tab_pas_mq
		?ST=1		11
		GOYES		suppr_tab_3b
			CBIT=0	4
			DAT1=C	B
			GOTO		suppr_tab_pas_mq 
suppr_tab_3b
		C=0		B
		DAT1=C	B
suppr_tab_pas_mq 
	D1=D1+	2
	A=A-1		B
	GONC		Ret_f_suppr_tab

	?ST=0		11		* pas de suppresion
	RTNYES

* il a eu des suppresions
	ST=0		11

	GOSUBL	Beep_suppression
* petite attente pour bien voir la combinaison qui s'efface
	LC(5)		#04000
suppr_tab_wait
	C=C-1		A
	GONC		suppr_tab_wait 
	
	GOSUBL	Affiche_Tableau

	RTN

Suppr_Tab_test
* sous routine de test de la bille pointe par D1 
* marquage de la bille si identique  C(P)
	A=DAT1	B		* pas la mme bille
	?A#C		P
	RTNYES
	?ABIT=1	4		* bille dj marque
	RTNYES
* ok on la marque
	ST=1		11
	ABIT=1	4
	DAT1=A	B
	D0=(2)	NB_BILLES_IDEM
	A=DAT0	B
	A=A+1		B
	DAT0=A	B			* une bille en +
	RTN


**********************************************************************
Suppr2_Tableau
**********************************************************************
* on supprime les billes non accroches 
* On va utiliser le Bit5 = 1 si la bille est accroche
* Utilisation de ST(10) et R0(A)
 
	ST=1		5		* faudra insrer les billes
	ST=0		10		* pas de nouvelle bille marque

	D0=(2)	NB_LIGNES_INSERT
	C=DAT0	B
	B=C		B		* B = numro de ligne
	D=0		B		* D = numro de bille
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,10		* on saute 1ere ligne
	R0=C.F	A
	D1=C
Ret_b_suppr2_tab
	C=DAT1	B				* lecture valeur de la bille
	?C#0		P				* pas de vide
	GOYES		suppr2_pas_vide
		GOTO	Fin_b_suppr2_tab
suppr2_pas_vide
		LA(1)	#F
		?C#A	P				* pas de MUR
		GOYES		suppr2_pas_MUR
			GOTO	Fin_b_suppr2_tab
suppr2_pas_MUR 
* On marque toujours les billes de la 1er ligne
			D0=(2)	NB_LIGNES_INSERT
			A=DAT0	B
			?B#A	B
			GOYES	suppr2_pas_lign0
				GOSUB		Suppr2_marque 
suppr2_pas_lign0
			?CBIT=0	5		* pas marque
			GOYES		Fin_b_suppr2_tab

* test avec bille prcdente	
				D1=D1-	2
				GOSUB		Suppr2_marque 
* test avec bille suivante
				D1=D1+	4
				GOSUB		Suppr2_marque 

				A=B		B
				?ABIT=0	0		* ligne paire ?
				GOYES		suppr2_tab_paire
* test avec bille ligne suivante
					D1=D1+	10
					D1=D1+	8
					GOSUB		Suppr2_marque 
* test avec bille ligne suivante + 1
					D1=D1+	2
					GOSUB		Suppr2_marque 
* test avec bille ligne prcdente + 1
					D1=D1-	10
					D1=D1-	10
					D1=D1-	10
					D1=D1-	10
					GOSUB		Suppr2_marque 
* test avec bille ligne prcdente
					D1=D1-	2
					GOSUB		Suppr2_marque 
					GOTO	Fin_b_suppr2_tab
suppr2_tab_paire 
* test avec bille ligne suivante - 1
				D1=D1+	10
				D1=D1+	6
				GOSUB		Suppr2_marque 
* test avec bille ligne suivante
				D1=D1+	2
				GOSUB		Suppr2_marque 
* test avec bille ligne prcdente
				D1=D1-	10
				D1=D1-	10
				D1=D1-	10
				D1=D1-	10
				GOSUB		Suppr2_marque 
* test avec bille ligne prcdente - 1
				D1=D1-	2
				GOSUB		Suppr2_marque 

Fin_b_suppr2_tab
	D=D+1		B		* bille suivante
	LC(2)		#0A		* fin de ligne ?
	?C#D		B
	GOYES		suppr2_tab_pas_l
		D=0	B
		B=B+1	B		* ligne suivante
		LC(2)	#0C		* 12 lignes
		D0=(2)	NB_LIGNES_INSERT
		A=DAT0	B
		C=C+A		B
		?B=C		B
		GOYES		suppr2_tab_fin
suppr2_tab_pas_l
	C=R0.F	A		* bille suivante
	C=C+CON	A,2
	R0=C.F	A
	D1=C
	GOTO		Ret_b_suppr2_tab 

suppr2_tab_fin
* on boucle tant que des billes ont t marques
	?ST=0		10
	GOYES		suppr2_tab_final
		GOTO		Suppr2_Tableau

suppr2_tab_final 

	ST=1		4
	GOSUBL	Affiche_Tableau	* on affiche les billes qui tombent
	ST=0		4

* on boucle sur toutes les billes pour supprimer ou effacer les flags
	ST=0		10
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,12		* on saute 1ere ligne + 1er mur
	D1=C
	LC(2)		#77		* (10 billes * 12 lignes) - 1
	D=C		B
Ret_f_suppr2_tab
	C=DAT1	B
	?C=0		P			* pas les vides
	GOYES		suppr2_tab_pas_m 
		LA(1)		#F
		?C=A		P		* pas les murs
		GOYES		suppr2_tab_pas_m 

			?CBIT=0	5	* test si marqu
			GOYES		suppr2_tombe
				CBIT=0	5
				DAT1=C	B
				GOTO		suppr2_tab_pas_m 
suppr2_tombe 
			ST=1		10	* la bille tombe !
			C=0		B
			DAT1=C	B
			D0=(2)	NB_BILLES_ENVOI 
			C=DAT0	B
			C=C+1		B
			DAT0=C	B	* incrment du nb de billes  envoyer 
suppr2_tab_pas_m 
	D1=D1+	2
	D=D-1		B
	GONC		Ret_f_suppr2_tab

	?ST=0		10		* pas de suppresion
	RTNYES

* il a eu des suppressions
	GOSUBL	Beep_tombe

	ST=0		10		* plus de test  faire
	GOSUBL	Affiche_Tableau

Suppr2_b_boucle
* boucle d'affichage
	GOSUBL	Copie_ecran_fond 
	GOSUBL	Copie_ecran_chut
	?ST=0		4
	RTNYES				* on QUITTE

	LC(2)		AFF_BILLE 
	R2=C.F	B			* on affiche la bille qui se dplace
	GOSUBL	Affiche_Bille 

	GOSUBL 	Copie_image_bas
	GOSUBL 	ChangeEcran		* Affichage !!!

	D0=(2)	SAV_TIMER2			* horloge
	A=DAT0	A
Suppr2_wait
	C=DAT0	A
	C=A-C		A
	?CBIT=0	9
	GOYES		Suppr2_wait

	GOSUBL	Bouge_ecran_chut

	GOTO		Suppr2_b_boucle 


Suppr2_marque
* sous routine de marquage de la bille pointe par D1 
	C=DAT1	B
	?CBIT=1	5		* dj marque
	RTNYES
	?C=0		P		* pas de vide
	RTNYES
	LA(1)	#F
	?C=A	P			* pas de MUR
	RTNYES

	CBIT=1	5	* on marque
	DAT1=C	B
	ST=1		10
	RTN


**********************************************************************
Affiche_Tableau
**********************************************************************
* Affichage du tableau des billes dans ECRAN_FOND ou ECRAN_CHUTE
* Utilisation de R0(A) et R1(B) !!!

* on efface l'cran de fond
	D0=(2)	ECRAN_FOND
	?ST=0		4
	GOYES		aff_tab_fond
		D0=(2)	ECRAN_CHUTE	*on affiche dans l'cran de chute
aff_tab_fond 
	C=DAT0	A
	R3=C.F	A			* cran de travail = ECRAN_FOND
	D1=C					* D1 dans cran de fond
	A=0		W
	LC(2)		#87			* = (((136pixels/4)*64lignes) / 16q) -1
aff_tab_eff_ecr
	DAT1=A	W
	D1=D1+	16
	C=C-1		B
	GONC		aff_tab_eff_ecr 

* on affiche toutes les billes du tableau
	D0=(2)	TABLEAU
	C=DAT0	A		* dbut tableau
	C=C+CON	A,10
	C=C+CON	A,12		* on saute 1ere ligne + 1er mur
	R0=C.F	A		* R0 = @ bille  afficher dans tableau
	D0=(2)	NB_LIGNES_INSERT
	C=DAT0	B
	R1=C.F	B		* R1 = numro de ligne
	?CBIT=0	0
	GOYES		aff_tab_deb_pair
* bille en 4,0
		LC(5)		#04000
		D0=(2)	TAB_BILLE_X 
		DAT0=C	A		
		C=0		A
		D0=(2)	TAB_BILLE_Y 
		DAT0=C	A
		GOTO		Aff_tab_bille
aff_tab_deb_pair 
* bille en 0,0
	C=0		A
	D0=(2)	TAB_BILLE_X 
	DAT0=C	A		
	D0=(2)	TAB_BILLE_Y 
	DAT0=C	A

Aff_tab_bille
	C=R0.F	A
	D1=C
	C=DAT1	B		
	?C=0		P
	GOYES		aff_tab_pas_bil
		?ST=0		4
		GOYES		Aff_tab_affich
			?CBIT=1	5		* bille accroche
			GOYES		aff_tab_pas_bil
Aff_tab_affich 
		D0=(2)	TAB_BILLE_TYPE 
		A=0		B
		DAT0=A	B
		DAT0=C	1			* type de la bille (1er quartet)

		LC(2)		TAB_BILLE 
		R2=C.F	B			* on affiche une bille du tableau
		GOSUBL	Affiche_Bille 
aff_tab_pas_bil

	D0=(2)	TAB_BILLE_X 
	A=DAT0	A
	ASR		A			* on enlve les dcimales
	ASR		A
	ASR		A
	A=A+CON	A,8			* X+8
	LC(2)		#38
	?A>C		B
	GOYES		aff_tab_ligne	* la ligne est finie
		ASL		A		* on remet les dcimales
		ASL		A
		ASL		A
		DAT0=A	A
		C=R0.F	A
		C=C+CON	A,2
		R0=C.F	A
		GOTO		Aff_tab_bille
aff_tab_ligne 
*ligne suivante
	D0=(2)	NB_LIGNES_INSERT
	A=DAT0	B
	LC(2)		#0D		* max 14 lignes affiches
	C=C+A		B
	A=R1.F	B		* R1 = numro de ligne
	A=A+1		B
	?A<=C		B
	GOYES		aff_tab_suiv
		D0=(2)	ECRAN0
		?ST=0		0
		GOYES		aff_tab_ecran0
			D0=(2)	ECRAN1
aff_tab_ecran0
		C=DAT0	A
		R3=C.F	A
		RTN				* FIN !!!!!
aff_tab_suiv	
	R1=A.F	B
	?ABIT=0	0
	GOYES		aff_tab_paire
* c'est une ligne impaire
		C=R0.F	A
		C=C+CON	A,6	* 8eme bille + mur fin + mur dbut
		R0=C.F	A
		D0=(2)	TAB_BILLE_X 
		LC(5)		#04000
		DAT0=C	A	* X = 4,000d
		D0=(2)	TAB_BILLE_Y 
		A=DAT0	A	
		LC(5)		#07000
		C=C+A		A
		DAT0=C	A	* Y=Y+7
		GOTO Aff_tab_bille
aff_tab_paire 
	C=R0.F	A
	C=C+CON	A,8	* 7eme et 8eme billes + mur fin + mur dbut
	R0=C.F	A
	D0=(2)	TAB_BILLE_X 
	C=0		A
	DAT0=C	A	* X = 0,000d
	D0=(2)	TAB_BILLE_Y 
	A=DAT0	A	
	LC(5)		#07000
	C=C+A		A
	DAT0=C	A	* Y=Y+7
	GOTO Aff_tab_bille 


**********************************************************************
Deplace_Bille
**********************************************************************
* Dplacement de la bille
* aux coordonnes (AFF_BILLE_X, AFF_BILLE_Y)
* avec une direction AFF_BILLE_DIRECT 

* dplacement des Y : facile, on dcrment du sinus
	D0=(2)	AFF_BILLE_DIRECT
	C=0		A
	C=DAT0	B	* la direction
	D=C		A	* sauvegarde dans D
	C=C+C		A	* on multiplie par 5
	C=C+C		A
	C=C+D		A

	D0=(2)	TAB_SIN
	A=DAT0	A
	C=C+A		A
	D1=C			* D1 sur le bon SIN
	A=DAT1	A

	D0=(2)	AFF_BILLE_Y		* on dcremente le Y
	C=DAT0	A
	C=C-A		A
	DAT0=C	A

* dplacement des X : plus dur, faut tester si on n'arrive pas au bord
	D0=(2)	AFF_BILLE_X
	C=DAT0	A
	CSR		A			* on supprime les 3 quartets dcimaux
	CSR		A
	CSR		A
	?C#0		B		* test si X = 0
	GOYES	depl_bill_pas0
		LC(2)		#4E	 inversion du pas
		C=C-D		B
		D=C		B
		D0=(2)	AFF_BILLE_DIRECT
		DAT0=C	B
		GOTO		depl_bill_pasmax 
depl_bill_pas0
	LA(2)		#38		* max X = 56d
	?C#A		B
	GOYES		depl_bill_pasmax
		LC(2)		#4E	 inversion du pas
		C=C-D		B
		D=C		B
		D0=(2)	AFF_BILLE_DIRECT
		DAT0=C	B
depl_bill_pasmax
	C=D		A	* recupration dans D
	C=C+C		A	* on multiplie par 5
	C=C+C		A
	C=C+D		A

	D0=(2)	TAB_COS
	A=DAT0	A
	C=C+A		A
	D1=C			* D1 sur le bon COS
	A=DAT1	A

	D0=(2)	AFF_BILLE_X		* on dcrmente le X
	C=DAT0	A
	C=C-A		A
	DAT0=C	A

	RTN


**********************************************************************
Affiche_Bille
**********************************************************************
* Affichage de la bille R2(B) (BILLE_X, BILLE_Y, BILLE_TYPE)
* dans l'cran de travail R3
* Attention : mise  jour de ST(1)

	ST=0		1			* pas de colision
	C=R4.F	A			* C dans datas
	C=R2.F	B
	D0=C					* sur X
	C=DAT0	A
	CSR		A			* on supprime les 3 quartets dcimaux
	CSR		A
	CSR		A
* on va multiplier par 34
	C=C+C		A			* x2
	B=C		A
	CSL		A			* x2x16
	C=C+B		A
	A=R3.F 	A			* lecture bon cran
	A=A+C		A			* sur la bonne abscisse
	CD0EX
	C=R2.F	B
	D0=C					* sur X
	D0=D0+	5			* sur Y
	C=DAT0	A
	CSR		A			* on supprime les 3 quartets dcimaux
	CSR		A
	CSR		A
	B=C		A			* sauve Y dans B
* on va diviser par 4 pour avoir le nb de quartets
	CSRB.F	A
	CSRB.F	A
	A=A+C		A
	D1=A					* D1 sur les bonnes coordonnes pour crire 

* maintenant il faut lire la bonne bille
	CD0EX
	C=R2.F	B
	D0=C					* sur X
	D0=D0+	10			* sur TYPE
	C=0		A
	C=DAT0	B
	CSL		A			* multiplication par 2q * 8 lignes
	D0=(2)	IMAG_BILLES
	A=DAT0	A
	C=C+A		A
	D0=C					* D0 sur la bonne bille

* on affiche la bille
	P=		15			* on utilise C(S)
	LC(1)		#7			* on affiche les 8 lignes
	P=		0
Rtn_aff_bille	
	C=0		X
	C=DAT0	B			* lecture bille
	?C=0		B
	GOYES		aff_b_vide
		A=B		A			* dcalage de 0  3 bits
		?ABIT=0	0
		GOYES aff_b_no_bit0
			C=C+C	X
aff_b_no_bit0
		?ABIT=0	1
		GOYES aff_b_no_bit1
			C=C+C	X
			C=C+C	X
aff_b_no_bit1

		A=DAT1	X
		?A=0		X
		GOYES		Aff_b_direct 
			ACEX		X
			D=C		X		* sauvegarde de la valeur lue dans D
			C=C&A		X
			?C=0		X
			GOYES		aff_b_pas_choc
				ST=1	1			* choc !
aff_b_pas_choc 
			C=D		X
			C=C!A		X			* OR avec l'affichage
Aff_b_direct
		DAT1=C	X
aff_b_vide 
	D0=D0+	2
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
	C=C-1		S
	GONC		Rtn_aff_bille	

	C=R4.F	A
	D0=C
	RTN


**********************************************************************
AffichBillesWait
**********************************************************************
* on affiche les billes en attente dans les 2 crans
* utilisation de R1(A) !!!!

	C=R3.F	A
	R1=C.F	A				* sauvegarde de R3 dans R1

* on va afficher dans ECRAN0
	D0=(2)	ECRAN0			* dans ECRAN0
	C=DAT0	A
	R3=C.F	A 
	LA(5)		#00173			* 10 lignes + partie mobile 
	C=C+A		A
	D1=C
	LC(2)		#35				* 54 lignes - 1
	A=0		B
Aff_bw_ret1
		A=DAT1	1
		ABIT=0	3
		ABIT=0	2
		DAT1=A	B			* on efface les anciennes billes 
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2
		C=C-1		B
	GONC		Aff_bw_ret1

	D0=(2)	NB_BILLES_RECEP		* toutes les billes reues
	C=DAT0	B
	D0=(2)	NB_BILLES_INSERT		* sont  afficher
	DAT0=C	B

	D0=(2)	WAIT_BILLE_X
	LC(5)		#38000			* = 56,000
	DAT0=C	A
	D0=(2)	WAIT_BILLE_Y
	LC(5)		#7D000			* = 125,000
	DAT0=C	A
Aff_bw_boucle
		D0=(2)	NB_BILLES_INSERT
		A=DAT0	B
		?A=0		B
		GOYES		Aff_bw_copy			* plus de billes
		LC(2)		#05
		?A<C		B
		GOYES		aff_bw_moins5
			A=A-C		B
			DAT0=A	B			* 5 billes en -
			D0=(2)	WAIT_BILLE_TYPE
			LC(5)		#17			* bille pleine
			DAT0=C	B
			GOTO		aff_bw_affich
aff_bw_moins5
		A=A-1		B
		DAT0=A	B			* une bille en -
		D0=(2)	WAIT_BILLE_TYPE
		LC(2)		#16			* bille vide
		DAT0=C	B
aff_bw_affich
		LC(2)		WAIT_BILLE 
		R2=C.F	B				* on affiche la bille wait
		GOSUBL	Affiche_Bille 

		D0=(2)	WAIT_BILLE_X
		A=DAT0	A
		LC(5)		#05000
		A=A-C		A				* X = X - 5.000
		DAT0=A	A
		C=A		A
		CSR		A				* on retire la partie dcimale
		CSR		A
		CSR		A
		?CBIT=1	7
		GOYES		Aff_bw_copy 		* si X ngatif on arrte
	GOTO Aff_bw_boucle 

Aff_bw_copy
* et copier dans ECRAN1
	D0=(2)	ECRAN0			* depuis ECRAN0
	C=DAT0	A
	D1=C
	D1=D1+	16
	D1=D1+	15				* au saute la partie mobile
	D0=(2)	ECRAN1			* dans ECRAN1
	C=DAT0	A
	D0=C
	D0=D0+	16
	D0=D0+	15				* au saute la partie mobile

	LC(2)		#3F				* 64 lignes - 1
Aff_bw_ret2
		A=DAT1	B			* copie les billes 
		DAT0=A	B
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2
		D0=D0+	16
		D0=D0+	16
		D0=D0+	2
		C=C-1		B
	GONC		Aff_bw_ret2

	C=R4.F	A
	D0=C
	C=R1.F	A
	R3=C.F	A				* restauration de R3 depuis R1

	RTN


**********************************************************************
Bouge_ecran_chut
**********************************************************************
* Decale vers la droite l'cran de chute

	D0=(2)	ECRAN_CHUTE
	A=DAT0	A
	LC(5)		#0086E		* (63 lignes * 34q) + 16
	C=C+A		A
	D1=C					* D1 dans cran de travail
	LA(2)		#3F			* = 64lignes -1
ret_bg_chute
	C=DAT1	7
	D1=D1+	1
	DAT1=C	7
	D1=D1-	1
	D1=D1-	16
	C=DAT1	W
	D1=D1+	1
	DAT1=C	W
	D1=D1-	16
	D1=D1-	3

	A=A-1		B
	GONC		ret_bg_chute

	RTN


**********************************************************************
Copie_ecran_chut
**********************************************************************
* Copie l'cran de chute dans l'cran R3
* au retour ST(4)=0 si cran chute vide 

	ST=0		4
	C=R3.F 	A			* lecture bon cran
	D1=C					* D1 dans cran de travail
	D0=(2)	ECRAN_CHUTE
	C=DAT0	A
	D0=C		A			* D0 dans cran de chute
	LC(2)		#3F			* = 64lignes -1
	B=C		B
ret_cp_chute
	C=DAT0	W			* copie des 23 * 4 premiers pixels
	?C=0		W
	GOYES		cp_chute_vide1
		ST=1	4
		A=DAT1	W
		C=C!A		W
		DAT1=C	W
cp_chute_vide1	
	D0=D0+	16
	D1=D1+	16
	C=0		W
	C=DAT0	8
	?C=0		W
	GOYES		cp_chute_vide2
		ST=1	4
		A=DAT1	8
		C=C!A		W
		DAT1=C	8
cp_chute_vide2
	D0=D0+	16			* ligne suivante
	D0=D0+	2
	D1=D1+	16
	D1=D1+	2

	B=B-1		B
	GONC		ret_cp_chute 

	C=R4.F	A
	D0=C		A			* D0 dans data
	RTN


**********************************************************************
Copie_ecran_fond
**********************************************************************
* Copie l'cran de fond dans l'cran R3

	C=R3.F 	A			* lecture bon cran
	D1=C					* D1 dans cran de travail
	D0=(2)	ECRAN_FOND
	C=DAT0	A
	D0=C		A			* D0 dans cran de fond
	LA(2)		#3F			* = 64lignes -1
ret_cp_ecr
	C=DAT0	W			* copie des 24 * 4 premiers pixels
	DAT1=C	W
	D0=D0+	16
	D1=D1+	16
	C=DAT0	8
	DAT1=C	8
	D0=D0+	16			* ligne suivante
	D0=D0+	2
	D1=D1+	16
	D1=D1+	2

	A=A-1		B
	GONC		ret_cp_ecr 

	C=R4.F	A
	D0=C		A			* D0 dans data
	RTN


**********************************************************************
Copie_image_bas
**********************************************************************
* Copie de l'image du bas dans l'cran R3
* (seulement la limite en pintille)

	C=R3.F 	A			* lecture bon cran
	D1=C					* D1 dans cran de travail
	D1=D1+	16			* on saute les 80 premiers pixels
	D1=D1+	4

	D0=(2)	IMAG_BAS 
	C=DAT0	A
	D0=C		A			* D0 dans image du bas
	LC(2)		#3F			* = 64lignes -1
	D=C		B
ret_cp_imag
	C=DAT0	4			* on fait un OR des 4*4 pixels
	A=DAT1	4
	C=C!A		A
	DAT1=C	4

	D0=D0+	14			* ligne suivante
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
	D=D-1		B
	GONC		ret_cp_imag

	C=R4.F	A
	D0=C		A			* D0 dans data
	RTN


**********************************************************************
ChangeEcran
**********************************************************************
* on inverse cran de travail / cran d'affichage

	?ST=0		0
	GOYES		ChgEcran_ecran0
		ST=0		0
		D0=(2)	ECRAN0
		GOTO		ChgEcran_fin 
ChgEcran_ecran0
	ST=1		0
	D0=(2)	ECRAN1
ChgEcran_fin
	C=DAT0	A
	R3=C.F 	A

* on attend que l'INT affiche le bon ecran
	D0=(2)	INT_EXECUTEE
	C=0		P
	DAT0=C	1	* mise a 0
ChgEcran_wait
	C=DAT0	1
	?C=0		P
	GOYES		ChgEcran_wait
	RTN


**********************************************************************
Echanges_2j 
**********************************************************************
* on reoit et envoie on les billes
	GOSUB		Recv_chr
	?A=0		B				* rien recu
	GOYES		Ech2j_envoi 
	
	LC(2)		#FF
	?A=C		B
	GOYES		Ech2j_envoi 

	LC(2)		#8F
	?A#C		B
	GOYES		Ech2j_pas_gagne
		GOLONG	test_gp_GAGNE	* l'autre a perdu !
Ech2j_pas_gagne 

* sinon c'est le nb de bille  ajouter
	D0=(2)	NB_BILLES_RECEP 
	C=DAT0	B
	C=C+A		B
	DAT0=C	B

	GOSUBL 	AffichBillesWait 

Ech2j_envoi
	D0=(2)	NB_BILLES_ENVOI
	A=DAT0	B
	?A=0		B
	RTNYES		* pas de billes  envoyer

	GOSUB		Emit_chr
	D0=(2)	NB_BILLES_ENVOI
	A=0		B
	DAT0=A	B			* plus de billes  envoyer

	RTN


**********************************************************************
Emit_chr
**********************************************************************
* on met A(B)

	?ST=0		6
	RTNYES			* pas 2 joueurs

* on attend que le port soit libre
	D1=(5)	#00112
EmitChr_wait1
	C=DAT1 B
* IS THE HP IS SENDING A PREVIOUS CHARACTER?
	?CBIT=1 1
	GOYES EmitChr_wait1	* YES? THEN WAIT

* flag mission ON
	D1=(2)	#0B
	C=DAT1	B
	CBIT=1	5
	DAT1=C	B

* mission de A(B)
	D1=(2)	#16
	DAT1=A	B

* on attend la fin de l'mission
	D1=(2)	#12
EmitChr_wait2
	C=DAT1 B
* WAIT UNTIL THE CHARACTER WAS EFFECTIVELY SEND
	?CBIT=1 1
	GOYES EmitChr_wait2	* YES? THEN WAIT

* flag mission OFF
	D1=(2)	#0B
	C=DAT1	B
	CBIT=0	5
	DAT1=C	B

	D0=(2)	SAUVE_EMIT 
	DAT0=A	B
	ST=1		8		* une donne vient d'tre mise
	RTN	


**********************************************************************
Recv_chr
**********************************************************************
* on recois A(B)
	A=0		B		* pas de valeur par dfaut
	?ST=0		6
	RTNYES			* pas 2 joueurs

* now we check if an error has occured:
	D1=(5)	#00111
	C=DAT1	B
	?CBIT=0 	2
	GOYES RecvChr_no_err	* ooops, there was an error
* WE WILL CLEAR THE ERROR BIT FLAG
	D1=(2)	#13
	LC(1)		#F
	DAT1=C	1
	D1=(2)	#11
	C=DAT1	B
RecvChr_no_err
	D1=(2)	#11
	C=DAT1	B
	?CBIT=1 	1		* receiver busy?
	GOYES		RecvChr_no_err 
	?CBIT=0 	0
	RTNYES			* Nothing to read

	D1=(2)	#14
	A=DAT1	B 		* We read the byte in the buffer..

	?ST=0		7
	RTNYES			* liaison par cble donc pas de rflexion !

* y a t-il eu rflexion par IR ?
	?ST=0		8		* pas de donne mise donc pas de rflexion
	RTNYES	

	ST=0		8
	D0=(2)	SAUVE_EMIT 
	C=DAT0	B
	?A#C		B
	RTNYES

	A=0		B		* donne par rflxion
	RTN


**********************************************************************
Init2Joueurs
**********************************************************************
* on initialise la connexion pour 2 joueurs
	?ST=1		6
	GOYES		Init2j_init_IO
		?ST=0		7
		RTNYES			* pas practice
		GOTO		Init2j_insert

Init2j_init_IO 
* interruptions inactives et fermeture IO
	D1=(5)	#00110
	C=0		B
	DAT1=C	B

* initialisation de la vitesse  1200Bds
	D1=(2)	#0D
	C=DAT1	1
	CBIT=0	0
	CBIT=0	1
	CBIT=0	2
	DAT1=C	1

* activation IR mode RS232
	?ST=0		7
	GOYES		Init2j_cable
		D1=(2)	#1A
		LC(2)	 	#04    %to set the bit 2 in 0011A
		DAT1=C B
Init2j_cable 

* ouverture IO
	D1=(2)	#10
	LC(2)		#88
	DAT1=C 	B

* on attend une rception en mettant #FF
Init2j_wait_chr
	LC(5)		#02000		* tempo
	D=C		A
Init2j_tempo
		LC(3)		#001
		OUT=C
		GOSBVL	=AINRTN
		?ABIT=0	6			* DROP = 0040
		GOYES		Init2j_pas_sorti
			GOLONG	Tch_Retour_RPL
Init2j_pas_sorti
		GOSUB		Recv_chr 
		?A#0		B
		GOYES		Init2j_sorti 

		D=D-1		A
	GONC		Init2j_tempo

	LA(2)		#FF
	GOSUB		Emit_chr 

	GOTO		Init2j_wait_chr 

Init2j_sorti 
	LA(2)		#FF			* dernier change si 1er  sortir
	GOSUB		Emit_chr 
	GOSUB		Recv_chr 

* on insre les X lignes
Init2j_insert
	GOSUBL	Insert_ligne

	D0=(2)	NB_LIGNES_INIT 
	C=DAT0	B
	C=C-1		B
	DAT0=C	B
	?C#0		B
	GOYES		Init2j_insert 

	?ST=1		6
	RTNYES

* en mode practice on rinitialise tout
	ST=0	7			* on annule le mode Practice
	D0=(2)	NB_LIGNES_INSERT
	A=0		B
	DAT0=A	B		* on annule le nb de ligne

	RTN


**********************************************************************
InitBilleNext
**********************************************************************
* on initialise le type de la bille suivante
* utilisation de R1(A) !!!!

	?ST=1		6				* 2 joueurs = bille alatoire
	GOYES		InitBilleN_RAND

	D0=(2)	SERIE_B_NEXT
	A=DAT0	A
	D1=A						* D1 dans bille suivante
	C=0		B
	C=DAT1	1				* lecture bille
	?C=0		P				* si 0 alors bille alatoire
	GOYES		InitBilleN_RAND

	A=A+1		A
	DAT0=A	A				* bille suivante

	LA(1)		#F				* on boucle ?
	?C#A		P				* si F on boucle
	GOYES		InitBilleN_ok

	D0=(2)	SERIE_B_DEBUT
	A=DAT0	A
	D0=(2)	SERIE_B_NEXT
	DAT0=A	A				* on repart du dbut de la srie
	GOTO		InitBilleNext


InitBilleN_RAND
* init type de bille alatoire
	D1=(5)	#00104			* dans le CRC (nb au hasard)
	C=0		B
	C=DAT1	1

InitBilleN_bcl
	CBIT=0	3				* valeur entre 0 et 7
	?C#0		B
	GOYES		InitBilleN_pas0
		LC(2)	#01				* bille =1 si null
InitBilleN_pas0
	GOSUB		test_BilleN			* test si la bille choisie et OK
	GONC		InitBilleN_RAND		* pas bonne -> une autre

InitBilleN_ok
	D0=(2)	NEXT_BILLE_TYPE 
	DAT0=C	B

* on crit dans les 2 crans de travail
	C=R3.F	A
	R1=C.F	A				* sauvegarde de R3 dans R1

	D0=(2)	ECRAN0			* dans ECRAN0
	C=DAT0	A
	R3=C.F	A 
*  on efface la bille
	D1=C
	D1=D1+	16	
	D1=D1+	14	
	A=0		B
	LC(2)		#07				* 8 lignes
InitBilleN_rtn1
	DAT1=A	B	
	D1=D1+	16	
	D1=D1+	16	
	D1=D1+	2
	C=C-1		B
	GONC		InitBilleN_rtn1

	LC(2)		NEXT_BILLE 
	R2=C.F	B				* on affiche la bille suivante
	GOSUBL	Affiche_Bille 

	D0=(2)	ECRAN1			* dans ECRAN1
	C=DAT0	A
	R3=C.F	A 
*  on efface la bille
	D1=C
	D1=D1+	16	
	D1=D1+	14	
	A=0		B
	LC(2)		#9				* 10 lignes
InitBilleN_rtn2
	DAT1=A	B	
	D1=D1+	16	
	D1=D1+	16	
	D1=D1+	2
	C=C-1		B
	GONC		InitBilleN_rtn2

	LC(2)		NEXT_BILLE 
	R2=C.F	B				* on affiche la bille suivante
	GOSUBL	Affiche_Bille 

	C=R1.F	A
	R3=C.F	A				* rcupration de R3 depuis R1

	RTN

test_BilleN
* sous routine pour tester sir la bille choisie est deja dans le tableau
* au retour : Carry set si elle existe

	D0=(2)	TABLEAU
	A=DAT0	A		* dbut tableau
	D1=A
	D1=D1+	16
	D1=D1+	6		* on saute 1ere ligne + 1 octet de la 2e
	A=DAT1	16
	?A#0		W
	GOYES		test_BilleN_lign
		RTNSC			* 1er ligne deja vide -> toutes les billes sont bonnes
test_BilleN_lign		

* on teste les 11 premieres lignes
	LA(2)		(10*11)-1
	B=A		B
test_BilleN_bcl
	A=DAT1	1
	?A#C		P
	GOYES		test_BilleN_non
		RTNSC			* on l'a trouve
test_BilleN_non
	D1=D1+	2
	B=B-1		B
	GONC test_BilleN_bcl

	RTNCC				* pas trouve


**********************************************************************
InitBille
**********************************************************************
* on initialise une bille sur son pas de tir

	D0=(2)	AFF_BILLE_X 
	LC(5)		#1C800			* = 28,500
	DAT0=C	A
	D0=(2)	AFF_BILLE_Y 
	LC(5)		#52800			* = 82,500
	DAT0=C	A

* init type = bille suivant
	D0=(2)	NEXT_BILLE_TYPE 
	C=DAT0	B
	D0=(2)	AFF_BILLE_TYPE 
	DAT0=C	B

* direction bille = direction canon
	D0=(2)	CANON_DIRECT
	C=DAT0	B
	D0=(2)	AFF_BILLE_DIRECT 
	DAT0=C	B

* nouvelle bille suivante
	GOSUBL	InitBilleNext

	ST=0		2			* pas de mouvement
	RTN


**********************************************************************
InitTime
**********************************************************************
* on sauvegarde la valeur courante du Timer pour pouvoir faire la diffrence
	D0=(2)	SAV_TIMER2
	C=DAT0	8
	D0=(2)	SAUVE_TIMER
	DAT0=C	8

	RTN


**********************************************************************
InitGame
**********************************************************************
* on initialise un buffer de 1FF quartets et
* on prend la 1er adresse finissant par 00 -> R4

	LC(5)	#001FF
	GOSBVL	=MAKE$N	* retourne une string
*					* R0(A) pointe sur l'entete
*					* D0 pointe dans son contenu
	A=D0
	LC(5)	#FF			* on dpasse la 1er adresse en 00
	A=A+C	A
	A=0	B
	R4=A.F	A		* R4 pointe dans la string  la 1ere adresse en 00
	D0=A

* init des flags ST
	CLRST				* tous les flags ST  0

* init image d'anim du monstre
	C=DAT1	A		* adresse Grob bas d'image
	C=C+CON	A,10		* saute le prologue + taille
	C=C+CON	A,10		* saute largeur et longueur
	D0=(2)	IMAGE_MONSTRE
	DAT0=C	A

* init image du bas
	D1=D1+	5		* stack RPL niveau 2
	C=DAT1	A		* adresse Grob bas d'image
	C=C+CON	A,10		* saute le prologue + taille
	C=C+CON	A,10		* saute largeur et longueur
	D0=(2)	IMAG_BAS 
	DAT0=C	A

* init images billes
	D1=D1+	5		* stack RPL niveau 3
	C=DAT1	A		* adresse Grob billes
	C=C+CON	A,10		* saute le prologue + taille
	C=C+CON	A,10		* saute largeur et longueur
	D0=(2)	IMAG_BILLES 
	DAT0=C	A

* init params IN
	D1=D1+	5		* stack RPL niveau 4
	C=DAT1	A		* adresse param #
	D0=C				* dans la param #
	D0=D0+	5		* on saute prologue
	C=DAT0	1		* lecture params
	?CBIT=0	0
	GOYES		Init_pas_parcour
		ST=1	3		* affichage parcours
Init_pas_parcour
	?CBIT=0	1
	GOYES		Init_pas_2joueur
		ST=1	6		* mode 2 joueurs
Init_pas_2joueur
	?CBIT=0	2
	GOYES		Init_pas_IR_Prac
		ST=1	7		* connexion par IR ou Practice
Init_pas_IR_Prac 
	D0=D0+	1		* on passe on nb de tir (bit4  11)
	A=DAT0	B		* A(B) =lecture nb de tirs
	D0=D0+	2		* on passe on nb de lignes (bit12  15)
	C=0		B
	C=DAT0	1
	B=C		B		* B(B) = nb de lignes
	C=R4.F	A
	D0=C				* retour dans Data
	D0=(2)	NB_TIRS_MAX
	DAT0=A	B
	D0=(2)	NB_TIRS_COURANT
	DAT0=A	B
	D0=(2)	NB_LIGNES_INIT 
	C=B		B
	DAT0=C	B
	 
* init srie de billes
	D1=D1+	5		* stack RPL niveau 5
	C=DAT1	A		* adresse Grob srie de bille
	C=C+CON	A,10		* saute le prologue + taille
	C=C+CON	A,10		* saute largeur et longueur
	D0=(2)	SERIE_B_DEBUT 
	DAT0=C	A
	D0=(2)	SERIE_B_NEXT 
	DAT0=C	A

* init tableau
	D1=D1+	5		* stack RPL niveau 6
	C=DAT1	A		* adresse Grob tableau
	C=C+CON	A,10		* saute le prologue + taille
	C=C+CON	A,10		* saute largeur et longueur
	D0=(2)	TABLEAU 
	DAT0=C	A

* init params OUT
	D1=D1+	5		* stack RPL niveau 7
	C=DAT1	A		* adresse param #
	C=C+CON	A,5		* saute le prologue
	D0=(2)	PARAMS_SORTIE
	DAT0=C	A

* init crans
	GOSBVL	=D0->Row1	* D0 et A(A) pointe dans le grob courant
	C=R4.F	A
	D0=C
	D0=(2)	ECRAN0
	DAT0=A	A
	R3=A.F	A		* cran de travail
	LC(5)		#00880	* au 2e cran (34 quartets par ligne * 64 lignes)
	A=A+C		A
	D0=(2)	ECRAN1
	DAT0=A	A
	A=A+C		A		* au 3e cran
	D0=(2)	ECRAN_FOND
	DAT0=A	A
	A=A+C		A		* au 4e cran
	D0=(2)	ECRAN_CHUTE 
	DAT0=A	A
	A=A+C		A		* au 5e cran
	D0=(2)	ECRAN_GRIS
	DAT0=A	A

* init canon
	D0=(2)	CANON_DIRECT
	LC(2)		#27		*  la verticale (39)
	DAT0=C	B

* init Bille suivante
	D0=(2)	NEXT_BILLE_X 
	LC(5)		#01000	* 1.0d
	DAT0=C	A
	D0=(2)	NEXT_BILLE_Y 
	LC(5)		#78000	* 120.0d
	DAT0=C	A
	GOSUBL	InitBilleNext

* init temps restant
	D0=(2)	TIME_BILLE_X 
	LC(5)		#22000			* = 34,000
	DAT0=C	A
	D0=(2)	TIME_BILLE_Y 
	LC(5)		#58000			* = 88,000
	DAT0=C	A

* init nb de billes, lignes et cpt  0
	C=0		B
	D0=(2)	NB_BILLES_ENVOI 
	DAT0=C	B
	D0=(2)	NB_BILLES_RECEP 
	DAT0=C	B
	D0=(2)	NB_LIGNES_INSERT 
	DAT0=C	B

* activation du timer
	D1=(2)	#0012F		*  on active l'horloge
	C=DAT1	1
	CBIT=1	0
	DAT1=C  	1

* sauvegarde TIMER2
	D1=(2)	#38
	C=DAT1	8
	D0=(2)	SAV_TIMER2
	DAT0=C	8  

* INT_EXECUTEE non executee
	D0=(2)	INT_EXECUTEE
	C=0		A
	DAT0=C	1

* INT_CPT a 0
	D0=(2)	INT_CPT
	DAT0=C	1

* init des Cosinus
	GOSUB	Init_COS
		CON(5) #00FA6	* COS(12)*16*16*16
		CON(5) #00F86	* COS(14)*16*16*16
		CON(5) #00F61	* COS(16)*16*16*16
		CON(5) #00F38	* COS(18)*16*16*16
		CON(5) #00F09	* COS(20)*16*16*16
		CON(5) #00ED6	* COS(22)*16*16*16
		CON(5) #00E9E	* COS(24)*16*16*16
		CON(5) #00E61	* COS(26)*16*16*16
		CON(5) #00E21	* COS(28)*16*16*16
		CON(5) #00DDB	* COS(30)*16*16*16
		CON(5) #00D92	* COS(32)*16*16*16
		CON(5) #00D44	* COS(34)*16*16*16
		CON(5) #00CF2	* COS(36)*16*16*16
		CON(5) #00C9C	* COS(38)*16*16*16
		CON(5) #00C42	* COS(40)*16*16*16
		CON(5) #00BE4	* COS(42)*16*16*16
		CON(5) #00B82	* COS(44)*16*16*16
		CON(5) #00B1D	* COS(46)*16*16*16
		CON(5) #00AB5	* COS(48)*16*16*16
		CON(5) #00A49	* COS(50)*16*16*16
		CON(5) #009DA	* COS(52)*16*16*16
		CON(5) #00968	* COS(54)*16*16*16
		CON(5) #008F2	* COS(56)*16*16*16
		CON(5) #0087B	* COS(58)*16*16*16
		CON(5) #00800	* COS(60)*16*16*16 = 0.500d 
		CON(5) #00783	* COS(62)*16*16*16
		CON(5) #00704	* COS(64)*16*16*16
		CON(5) #00682	* COS(66)*16*16*16
		CON(5) #005FE	* COS(68)*16*16*16
		CON(5) #00579	* COS(70)*16*16*16
		CON(5) #004F2	* COS(72)*16*16*16
		CON(5) #00469	* COS(74)*16*16*16
		CON(5) #003DF	* COS(76)*16*16*16
		CON(5) #00354	* COS(78)*16*16*16
		CON(5) #002C7	* COS(80)*16*16*16
		CON(5) #0023A	* COS(82)*16*16*16
		CON(5) #001AC	* COS(84)*16*16*16
		CON(5) #0011E	* COS(86)*16*16*16
		CON(5) #0008F	* COS(88)*16*16*16
		CON(5) #00000	* COS(90)*16*16*16 = 0.000d 
		CON(5) #FFF71	* COS(92)*16*16*16
		CON(5) #FFEE2	* COS(94)*16*16*16
		CON(5) #FFE54	* COS(96)*16*16*16
		CON(5) #FFDC6	* COS(98)*16*16*16
		CON(5) #FFD39	* COS(100)*16*16*16
		CON(5) #FFCAC	* COS(102)*16*16*16
		CON(5) #FFC21	* COS(104)*16*16*16
		CON(5) #FFB97	* COS(106)*16*16*16
		CON(5) #FFB0E	* COS(108)*16*16*16
		CON(5) #FFA87	* COS(110)*16*16*16
		CON(5) #FFA02	* COS(112)*16*16*16
		CON(5) #FF97E	* COS(114)*16*16*16
		CON(5) #FF8FC	* COS(116)*16*16*16
		CON(5) #FF87D	* COS(118)*16*16*16
		CON(5) #FF800	* COS(120)*16*16*16 = -0.500d 
		CON(5) #FF785	* COS(122)*16*16*16
		CON(5) #FF70E	* COS(124)*16*16*16
		CON(5) #FF698	* COS(126)*16*16*16
		CON(5) #FF626	* COS(128)*16*16*16
		CON(5) #FF5B7	* COS(130)*16*16*16
		CON(5) #FF54B	* COS(132)*16*16*16
		CON(5) #FF4E3	* COS(134)*16*16*16
		CON(5) #FF47E	* COS(136)*16*16*16
		CON(5) #FF41C	* COS(138)*16*16*16
		CON(5) #FF3BE	* COS(140)*16*16*16
		CON(5) #FF364	* COS(142)*16*16*16
		CON(5) #FF30E	* COS(144)*16*16*16
		CON(5) #FF2BC	* COS(146)*16*16*16
		CON(5) #FF26E	* COS(148)*16*16*16
		CON(5) #FF225	* COS(150)*16*16*16
		CON(5) #FF1DF	* COS(152)*16*16*16
		CON(5) #FF19F	* COS(154)*16*16*16
		CON(5) #FF162	* COS(156)*16*16*16
		CON(5) #FF12A	* COS(158)*16*16*16
		CON(5) #FF0F7	* COS(160)*16*16*16
		CON(5) #FF0C8	* COS(162)*16*16*16
		CON(5) #FF09F	* COS(164)*16*16*16
		CON(5) #FF07A	* COS(166)*16*16*16
		CON(5) #FF05A	* COS(168)*16*16*16
Init_COS
	C=RSTK
	D0=(2)	TAB_COS
	DAT0=C	A

* init des Sinus
	GOSUB	Init_SIN
		CON(5) #00354	* SIN(12)*16*16*16
		CON(5) #003DF	* SIN(14)*16*16*16
		CON(5) #00469	* SIN(16)*16*16*16
		CON(5) #004F2	* SIN(18)*16*16*16
		CON(5) #00579	* SIN(20)*16*16*16
		CON(5) #005FE	* SIN(22)*16*16*16
		CON(5) #00682	* SIN(24)*16*16*16
		CON(5) #00704	* SIN(26)*16*16*16
		CON(5) #00783	* SIN(28)*16*16*16
		CON(5) #00800	* SIN(30)*16*16*16 = 0.500d
		CON(5) #0087B	* SIN(32)*16*16*16
		CON(5) #008F2	* SIN(34)*16*16*16
		CON(5) #00968	* SIN(36)*16*16*16
		CON(5) #009DA	* SIN(38)*16*16*16
		CON(5) #00A49	* SIN(40)*16*16*16
		CON(5) #00AB5	* SIN(42)*16*16*16
		CON(5) #00B1D	* SIN(44)*16*16*16
		CON(5) #00B82	* SIN(46)*16*16*16
		CON(5) #00BE4	* SIN(48)*16*16*16
		CON(5) #00C42	* SIN(50)*16*16*16
		CON(5) #00C9C	* SIN(52)*16*16*16
		CON(5) #00CF2	* SIN(54)*16*16*16
		CON(5) #00D44	* SIN(56)*16*16*16
		CON(5) #00D92	* SIN(58)*16*16*16
		CON(5) #00DDB	* SIN(60)*16*16*16
		CON(5) #00E21	* SIN(62)*16*16*16
		CON(5) #00E61	* SIN(64)*16*16*16
		CON(5) #00E9E	* SIN(66)*16*16*16
		CON(5) #00ED6	* SIN(68)*16*16*16
		CON(5) #00F09	* SIN(70)*16*16*16
		CON(5) #00F38	* SIN(72)*16*16*16
		CON(5) #00F61	* SIN(74)*16*16*16
		CON(5) #00F86	* SIN(76)*16*16*16
		CON(5) #00FA6	* SIN(78)*16*16*16
		CON(5) #00FC2	* SIN(80)*16*16*16
		CON(5) #00FD8	* SIN(82)*16*16*16
		CON(5) #00FEA	* SIN(84)*16*16*16
		CON(5) #00FF6	* SIN(86)*16*16*16
		CON(5) #00FFE	* SIN(88)*16*16*16
		CON(5) #01000	* SIN(90)*16*16*16 = 1.000d
		CON(5) #00FFE	* SIN(92)*16*16*16
		CON(5) #00FF6	* SIN(94)*16*16*16
		CON(5) #00FEA	* SIN(96)*16*16*16
		CON(5) #00FD8	* SIN(98)*16*16*16
		CON(5) #00FC2	* SIN(100)*16*16*16
		CON(5) #00FA6	* SIN(102)*16*16*16
		CON(5) #00F86	* SIN(104)*16*16*16
		CON(5) #00F61	* SIN(106)*16*16*16
		CON(5) #00F38	* SIN(108)*16*16*16
		CON(5) #00F09	* SIN(110)*16*16*16
		CON(5) #00ED6	* SIN(112)*16*16*16
		CON(5) #00E9E	* SIN(114)*16*16*16
		CON(5) #00E61	* SIN(116)*16*16*16
		CON(5) #00E21	* SIN(118)*16*16*16
		CON(5) #00DDB	* SIN(120)*16*16*16
		CON(5) #00D92	* SIN(122)*16*16*16
		CON(5) #00D44	* SIN(124)*16*16*16
		CON(5) #00CF2	* SIN(126)*16*16*16
		CON(5) #00C9C	* SIN(128)*16*16*16
		CON(5) #00C42	* SIN(130)*16*16*16
		CON(5) #00BE4	* SIN(132)*16*16*16
		CON(5) #00B82	* SIN(134)*16*16*16
		CON(5) #00B1D	* SIN(136)*16*16*16
		CON(5) #00AB5	* SIN(138)*16*16*16
		CON(5) #00A49	* SIN(140)*16*16*16
		CON(5) #009DA	* SIN(142)*16*16*16
		CON(5) #00968	* SIN(144)*16*16*16
		CON(5) #008F2	* SIN(146)*16*16*16
		CON(5) #0087B	* SIN(148)*16*16*16
		CON(5) #00800	* SIN(150)*16*16*16 = 0.500d
		CON(5) #00783	* SIN(152)*16*16*16
		CON(5) #00704	* SIN(154)*16*16*16
		CON(5) #00682	* SIN(156)*16*16*16
		CON(5) #005FE	* SIN(158)*16*16*16
		CON(5) #00579	* SIN(160)*16*16*16
		CON(5) #004F2	* SIN(162)*16*16*16
		CON(5) #00469	* SIN(164)*16*16*16
		CON(5) #003DF	* SIN(166)*16*16*16
		CON(5) #00354	* SIN(168)*16*16*16
Init_SIN
	C=RSTK
	D0=(2)	TAB_SIN
	DAT0=C	A

	RTN


**********************************************************************
Beep_suppression
**********************************************************************
* bruitage lors de la suppression de billes
	D0=(2)	SAUVE_ST	* sauvegarde des registres modifis par le Beep
	C=ST
	DAT0=C	X
	D0=(2)	SAUVE_R3
	C=R3
	DAT0=C	A

	LC(5)		#00640	* frquence = 1600
	D=C		A
	LC(5)		#00064	* dure = 0.1 seconde
	GOSBVL	=makebeep

	C=R4.F	A		* restauration des registres modifis par le Beep 
	D0=C
	D0=(2)	SAUVE_ST
	C=DAT0	X
	ST=C
	D0=(2)	SAUVE_R3
	C=DAT0	A
	R3=C
	RTN

**********************************************************************
Beep_tombe
**********************************************************************
* bruitage lorsque les billes tombent
	D0=(2)	SAUVE_ST	* sauvegarde des registres modifis par le Beep
	C=ST
	DAT0=C	X
	D0=(2)	SAUVE_R3
	C=R3
	DAT0=C	A

	LC(5)		#00064	* frquence = 100
	D=C		A
	LC(5)		#00096	* dure = 0.15 seconde
	GOSBVL	=makebeep

	C=R4.F	A		* restauration des registres modifis par le Beep 
	D0=C
	D0=(2)	SAUVE_ST
	C=DAT0	X
	ST=C
	D0=(2)	SAUVE_R3
	C=DAT0	A
	R3=C
	RTN

**********************************************************************
Beep_mvt_canon
**********************************************************************
* bruitage lors du dplacement du canon
	D0=(2)	SAUVE_ST	* sauvegarde des registres modifis par le Beep
	C=ST
	DAT0=C	X
	D0=(2)	SAUVE_R3
	C=R3
	DAT0=C	A

	LC(5)		#00064	* frquence = 100
	D=C		A
	LC(5)		#0000A	* dure = 0.01 seconde
	GOSBVL	=makebeep

	C=R4.F	A		* restauration des registres modifis par le Beep 
	D0=C
	D0=(2)	SAUVE_ST
	C=DAT0	X
	ST=C
	D0=(2)	SAUVE_R3
	C=DAT0	A
	R3=C
	RTN

**********************************************************************
Beep_tir_canon
**********************************************************************
* bruitage lors du tir du canon
	D0=(2)	SAUVE_ST	* sauvegarde des registres modifis par le Beep
	C=ST
	DAT0=C	X
	D0=(2)	SAUVE_R3
	C=R3
	DAT0=C	A

	LC(5)		#000DC	* frquence = 220
	D=C		A
	LC(5)		#00064	* dure = 0.1 seconde
	GOSBVL	=makebeep

	C=R4.F	A		* restauration des registres modifis par le Beep 
	D0=C
	D0=(2)	SAUVE_ST
	C=DAT0	X
	ST=C
	D0=(2)	SAUVE_R3
	C=DAT0	A
	R3=C
	RTN

**********************************************************************
Beep_insert_lign
**********************************************************************
* bruitage lors du tir du canon
	D0=(2)	SAUVE_ST	* sauvegarde des registres modifis par le Beep
	C=ST
	DAT0=C	X
	D0=(2)	SAUVE_R3
	C=R3
	DAT0=C	A

	LC(5)		#002BC	* frquence = 700
	D=C		A
	LC(5)		#00064	* dure = 0.1 seconde
	GOSBVL	=makebeep

	D=0		A		* frquence = 0 (pause)
	LC(5)		#000C8	* dure = 0.2 seconde
	GOSBVL	=makebeep

	LC(5)		#002BC	* frquence = 700
	D=C		A
	LC(5)		#00064	* dure = 0.1 seconde
	GOSBVL	=makebeep

	C=R4.F	A		* restauration des registres modifis par le Beep 
	D0=C
	D0=(2)	SAUVE_ST
	C=DAT0	X
	ST=C
	D0=(2)	SAUVE_R3
	C=DAT0	A
	R3=C
	RTN


	INCLUDE INTER.S
	INCLUDE ANIMONSTER.S
ENDCODE
}
